#!/usr/bin/env bash
export CXX="-O2 -march=native -fomit-frame-pointer"
MODE="FULL"
while getopts "fhmc" i; do
    case "$i" in
        m)
            MODE="MAKE"
            ;;
        c)
            CLEAN=0
            ;;
        *)
            echo -e "$0 [arg] [arg]\n\t-m\t\t\t make only\n\t-c\t\t\t do an make clean additionally"
            exit 0
            ;;
    esac
done


BPATH="`pwd|rev|cut -d"/" -f3-|rev`"

_bfail() { 
    echo "BUILD FAILED"
    exit 1
}








##main
for i in "libhamcast" "middleware" "modules/ip"; do
    echo -e "--\n$BPATH/$i:\n"
    cd "$BPATH/$i"
    [[ $MODE == "FULL" ]] && { autoreconf -fvi && ./configure -DDISABLE_SD --with-hamcast-libdir=../../libhamcast || _bfail; }
    [[ $CLEAN ]] && make clean
    make || _bfail
done


[[ ! -f "$BPATH/middleware/middleware.init" ]] &&  cp "$BPATH/modules/ip/middleware.ini" "$BPATH/middleware/"
